<?php
/*
*   GENERACION DE LAS ESTRUCTURAS DE DATOS EN FICHEROS JS PARA CADA GRAFICO
*
*   DEPENDIENDO DE LA MAQUINA EN LA QUE SE EJECUTE PUEDE SER NECESARIO DESACTIVAR
*   EL TIEMPO MAXIMO DE EJECUCION DE LOS SCRIPTS PHP EN EL SERVIDOR
*
*/

require_once('include/include.php');

$data = new Data();

$cps = $data->get_cps();
$months = array('ENE', 'FEB', 'MAR', 'ABR', 'MAY', 'JUN', 'JUL', 'AGO', 'SET', 'OCT', 'NOV', 'DIC');
$hours = array('00-02', '02-04', '04-06', '06-08', '08-10', '10-12', '12-14', '14-16', '16-18', '18-20', '20-22', '22-24');

$months_number = array(1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12);
$month_days = array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);


/* GENERAR EL JS INICIAL DEL DASHBOARD */
//generate_data_dashboard($months, $data);

/* GENERAR EL JS DEL DASHBOARD POR CP */
//generate_data_dashboard_cp($months, $data, $cps);

/* GENERAR EL JS DEL RADARCHART POR CP */
//generate_data_radarChart($hours, $data);

/* GENERAR EL JS INICIAL DEL RADARCHART */
//generate_data_radarChart_cp($hours, $cps, $data);

/* GENERAR EL JS INICIAL DEL METEO */
//generate_data_meteo($months_number, $month_days, $data);

/* GENERAR EL JS INICIAL DEL METEO por CP */
generate_data_meteo_cp($months_number, $month_days, $cps, $data);

/*
*   FUNCIONES PARA LA GENERACION DE LAS ESTRUCTURAS DE DATOS
*/

/*
*   Genera la estructura de datos para el meteochart inicial
*
*   @param      array $months_number Array con el numero del mes
*   @param      array $month_days Array con el numero de dias de cada mes
*   @param      object $data Objecto de la clase Data
*/
function generate_data_meteo($months_number, $month_days, $data){
    
    echo "generating meteo data";
    
    $var_string_1 = "[";
    $var_string_2 = "[";
    
    foreach($months_number as $month){
        for($day = 1; $day <= $month_days[$month-1]; $day++){
            $item = $data->get_total_day($day, $month);
            $temp = $data->get_temp_day($day, $month);
            
            $var_string_1 = $var_string_1.$item.",";
            $var_string_2 = $var_string_2.$temp.",";
        }
    }
    
    
    
    $var_string_1 = rtrim($var_string_1,',')."]";
    $var_string_2 = rtrim($var_string_2,',')."]";

    $fichero = fopen("include/data/data_general_1.js", "w") or die("Unable to open file!");
    fwrite($fichero, $var_string_1);
    fclose($fichero);   
    
    $fichero = fopen("include/data/data_general_2.js", "w") or die("Unable to open file!");
    fwrite($fichero, $var_string_2);
    fclose($fichero);  
}

/*
*   Genera la estructura de datos para el meteochart de cada CP
*
*   @param      array $months_number Array con el numero del mes
*   @param      array $month_days Array con el numero de dias de cada mes
*   @param      object $data Objecto de la clase Data
*/
function generate_data_meteo_cp($months_number, $month_days, $cps, $data){
    
    echo "generating meteo data";
    
    foreach($cps as $cp){
        
        if($cp > 46001){
            $var_string_1 = "[";
            $var_string_2 = "[";

            foreach($months_number as $month){
                for($day = 1; $day <= $month_days[$month-1]; $day++){
                    $item = $data->get_total_day_cp($day, $month, $cp);
                    $temp = $data->get_temp_day($day, $month);

                    $var_string_1 = $var_string_1.$item.",";
                    $var_string_2 = $var_string_2.$temp.",";
                }
            }

            $var_string_1 = rtrim($var_string_1,',')."]";
            $var_string_2 = rtrim($var_string_2,',')."]";

            $fichero = fopen("include/data/meteo/data_".$cp.".js", "w") or die("Unable to open file!");
            fwrite($fichero, $var_string_1);

            fwrite($fichero, " || ");

            fwrite($fichero, $var_string_2);
            fclose($fichero);  
        }
        
    }
  
}

/*
*   Genera la estructura de datos para el radarChart inicial
*
*   @param      array $hours Array con la lista de franjas horarias
*   @param      object $data Objecto de la clase Data
*/
function generate_data_radarChart($hours, $data){
    
    $aux_count = 0;
    //$max = $data->get_max_import();
    //$min = $data->get_min_import();
    $var_string = "[";
    foreach($data->sectors_name as $sector){ 
        $var_string = $var_string."[";
        $hour_count = 0;
        foreach($hours as $hour){
            $item = $data->get_average_hours_sector($sector);
            
            $val = ($item[$hours[$hour_count]] - $min) / ($max - $min);
            
            $var_string = $var_string."{axis:'".$hours[$hour_count]."',value:".$item[$hours[$hour_count]]."}";
            if($hour_count < 11){
                $var_string = $var_string.",\n";
            }
            $hour_count++;
        }
        $var_string = $var_string."]";
        if($aux_count < 11){
            $var_string = $var_string.",\n";
        }
        $aux_count++;
    }
    $var_string = $var_string."]";
    echo $var_string;

    $fichero = fopen("include/data/radarChart/data_general.js", "w") or die("Unable to open file!");
    fwrite($fichero, $var_string);
    fclose($fichero);   
}

/*
*   Genera la estructura de datos para el radarChart de cada CP
*
*   @param      array $hours Array con la lista de franjas horarias
*   @param      object $data Objecto de la clase Data
*/
function generate_data_radarChart_cp($hours, $cps, $data){
    
    foreach($cps as $cp){
        $aux_count = 0;
        //$max = $data->get_max_import_cp($cp);
        //$min = $data->get_min_import_cp($cp);
        $var_string = "[";
        foreach($data->sectors_name as $sector){ 
            $var_string = $var_string."[";
            $hour_count = 0;
            foreach($hours as $hour){
                $item = $data->get_average_hours_sector_cp($sector, $cp);
                
                //$val = ($item[$hours[$hour_count]] - $min) / ($max - $min);
                
                $var_string = $var_string."{axis:'".$hours[$hour_count]."',value:".$item[$hours[$hour_count]]."}";
                if($hour_count < 11){
                    $var_string = $var_string.",\n";
                }
                $hour_count++;
            }
            $var_string = $var_string."]";
            if($aux_count < 11){
                $var_string = $var_string.",\n";
            }
            $aux_count++;
        }
        $var_string = $var_string."]";
        echo $var_string;

        $fichero = fopen("include/data/radarChart/data_".$cp.".js", "w") or die("Unable to open file!");
        fwrite($fichero, $var_string);
        fclose($fichero); 
    }
    
}

/*
*   Genera la estructura de datos para el dashboard inicial
*
*   @param      array $months Array con la lista de meses
*   @param      object $data Objecto de la clase Data
*/
function generate_data_dashboard($months, $data){
    
    $month_count = 0;
    $var_string = "[";
    
    foreach($months as $month){
        $item = $data->get_total_byMonth_($month_count+1);
        $var_string = 
        $var_string."{month:'".$months[$month_count]."',
             freq:{ALIMENTACION:".$item['ALIMENTACION'].", 
                   AUTO:".$item['AUTO'].", 
                   BELLEZA:".$item['BELLEZA'].", 
                   HIPERMERCADOS:".$item['HOGAR'].",
                   HOGAR:".$item['HIPERMERCADOS'].",
                   MODA:".$item['MODA'].", 
                   OCIO:".$item['OCIO'].", 
                   OTROS:".$item['OTROS'].", 
                   RESTAURACION:".$item['RESTAURACION'].", 
                   SALUD:".$item['SALUD'].", 
                   TECNOLOGIA:".$item['TECNOLOGIA']." }}";
        if($month_count+1 < 12){
            $var_string = $var_string.",";
        }
        $month_count++;
    }
    $var_string = $var_string."]";
    echo $var_string;

    $fichero = fopen("include/data/dashboard/data_general.js", "w") or die("Unable to open file!");
    fwrite($fichero, $var_string);
    fclose($fichero);   
}

/*
*   Genera la estructura de datos para el dashboard por CP
*
*   @param      array $months Array con la lista de meses
*   @param      object $data Objecto de la clase Data
*/
function generate_data_dashboard_cp($months, $data, $cps){
    
    $month_count = 0;
    $var_string = "";
    
    foreach($cps as $cp){
        
        if($cp > 46135){
            echo "encontrado";
            $month_count = 0;
            $var_string = "[";
            foreach($months as $month){
                $item = $data->get_total_byMonth_and_cp($month_count+1, $cp);
                var_dump($item);
                $var_string = 
                $var_string."{month:'".$months[$month_count]."',
                     freq:{ALIMENTACION:".$item['ALIMENTACION'].", 
                           AUTO:".$item['AUTO'].", 
                           BELLEZA:".$item['BELLEZA'].", 
                           HIPERMERCADOS:".$item['HOGAR'].",
                           HOGAR:".$item['HIPERMERCADOS'].",
                           MODA:".$item['MODA'].", 
                           OCIO:".$item['OCIO'].", 
                           OTROS:".$item['OTROS'].", 
                           RESTAURACION:".$item['RESTAURACION'].", 
                           SALUD:".$item['SALUD'].", 
                           TECNOLOGIA:".$item['TECNOLOGIA']." }}";
                if($month_count+1 < 12){
                    $var_string = $var_string.",";
                }
                $month_count++;
            }
            $var_string = $var_string."]";
            echo $cp." | ";

            $fichero = fopen("include/data/dashboard/data_".$cp.".js", "w") or die("Unable to open file!");
            fwrite($fichero, $var_string);
            fclose($fichero);
            
        }

    }
}

?>