<?php

class Data{
    
    var $sectors_name = array('ALIMENTACION', 'AUTO', 'BELLEZA', 'HOGAR', 'HIPERMERCADOS', 'MODA', 'OCIO', 'OTROS', 'RESTAURACION', 'SALUD', 'TECNOLOGIA');
    
    var $sectors = array('ALIMENTACION'=>0, 'AUTO'=>0, 'BELLEZA'=>0, 'HOGAR'=>0, 'HIPERMERCADOS'=>0, 'MODA'=>0, 'OCIO'=>0, 'OTROS'=>0, 'RESTAURACION'=>0, 'SALUD'=>0, 'TECNOLOGIA'=>0);
    
    var $hours = array('00-02'=>0, '02-04'=>0, '04-06'=>0, '06-08'=>0, '08-10'=>0, '10-12'=>0, '12-14'=>0, '14-16'=>0, '16-18'=>0, '18-20'=>0, '20-22'=>0, '22-24'=>0);
    
    /* 
    *
    * Constructor
    *
    */ 
    function __construct($dataset = -1){  
        return $this;
    }
    
    /* 
    *
    * Metodos de la clase
    *
    */ 


    public function get_total_byMonth($month){ 
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe), sector, cp_comercio FROM dataset_cajamar WHERE MONTH(fecha) = ? GROUP BY sector
			")){
            $sql->bind_param("s", $month);
            if($sql->execute())
                if(!$sql->bind_result($total, $sector, $cp)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            $item = array();
            $item['sector'] = $sector;
            $item['importe'] = intval($total);
            $item['cp'] = $cp;
            array_push($result, $item);
            unset($item);
        }
        
        
        
        return $result;
        
    }
    
    public function get_total_byMonth_($month){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe), sector FROM dataset_cajamar WHERE MONTH(fecha) = ? GROUP BY sector
			")){
            $sql->bind_param("s", $month);
            if($sql->execute())
                if(!$sql->bind_result($total, $sector)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = $this->sectors;
        while($sql->fetch()){
            $item = array();
            if($total == ""){
                $val = 0;                
            }
            else{
                $val = intval($total);
            }
            $result[$sector] = $val;
        }
        
        
        
        return $result;
        
    }
    
    public function get_total_byMonth_and_cp($month, $cp){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe), sector FROM dataset_cajamar WHERE MONTH(fecha) = ? AND cp_cliente = ? GROUP BY sector
			")){
            $sql->bind_param("ss", $month, $cp);
            if($sql->execute())
                if(!$sql->bind_result($total, $sector)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = $this->sectors;
        while($sql->fetch()){
            $item = array();
            if($total == ""){
                $val = 0;                
            }
            else{
                $val = intval($total);
            }
            $result[$sector] = $val;
        }
        
        
        
        return $result;
        
    }
    
    public function get_cps_comercio(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT cp_comercio FROM dataset_cajamar WHERE 1 GROUP BY cp_comercio
			")){
            if($sql->execute())
                if(!$sql->bind_result($cp)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            array_push($result, $cp);
        }
        
        
        
        return $result;
        
    }
    
    public function get_cps_cliente(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT cp_cliente FROM dataset_cajamar WHERE 1 GROUP BY cp_cliente
			")){
            if($sql->execute())
                if(!$sql->bind_result($cp)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            array_push($result, $cp);
        }
        
        
        
        return $result;
        
    }
    
    public function get_cps(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT cp_cliente FROM dataset_cajamar WHERE 1 GROUP BY cp_cliente
			")){
            if($sql->execute())
                if(!$sql->bind_result($cp)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            array_push($result, $cp);
        }
        
        
        
        return $result;
        
    }
    
    public function get_cps_comunidad(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT cp FROM dataset_cp WHERE 1 ORDER BY cp
			")){
            if($sql->execute())
                if(!$sql->bind_result($cp)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            array_push($result, $cp);
        }
        
        
        
        return $result;
        
    }
    
    public function get_sectors(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT sector FROM dataset_cajamar GROUP BY sector
			")){
            
            if($sql->execute())
                if(!$sql->bind_result($sector)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = array();
        while($sql->fetch()){
            array_push($result, $sector);
        }
        
        
        
        return $result;
        
    }    
    
    public function get_average_hours_sector($sector){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe), franja_horaria FROM dataset_cajamar WHERE sector = ? GROUP BY franja_horaria
			")){
            $sql->bind_param("s", $sector);
            if($sql->execute())
                if(!$sql->bind_result($total, $hour)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = $this->hours;
        while($sql->fetch()){
            $item = array();
            if($total == ""){
                $val = 0;                
            }
            else{
                $val = intval($total);
            }
            $result[$hour] = $val;
        }
        
        
        
        return $result;
        
    }
    
    public function get_average_hours_sector_cp($sector, $cp){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe), franja_horaria FROM dataset_cajamar WHERE sector = ? AND cp_cliente = ? GROUP BY franja_horaria
			")){
            $sql->bind_param("ss", $sector, $cp);
            if($sql->execute())
                if(!$sql->bind_result($total, $hour)){
                    return false;
                }
        }
        else{
            return false;   
        }
        
        $result = $this->hours;
        while($sql->fetch()){
            $item = array();
            if($total == ""){
                $val = 0;                
            }
            else{
                $val = intval($total);
            }
            $result[$hour] = $val;
        }
        
        
        
        return $result;
        
    }
    
     
    public function get_total_day($day, $month, $year = 2016){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe) FROM dataset_cajamar WHERE DAY(fecha) = ? AND MONTH(fecha) = ? AND YEAR(fecha) = ?
        ")){
            $sql->bind_param("sss", $day, $month, $year);
            if($sql->execute())
                if(!$sql->bind_result($sum)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $sum;
        
    }   

    public function get_total_day_cp($day, $month, $cp, $year = 2016){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT SUM(importe) FROM dataset_cajamar WHERE DAY(fecha) = ? AND MONTH(fecha) = ? AND YEAR(fecha) = ? AND cp_cliente = ?
        ")){
            $sql->bind_param("ssss", $day, $month, $year, $cp);
            if($sql->execute())
                if(!$sql->bind_result($sum)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $sum;
        
    }  
    
    
    public function get_temp_day($day, $month, $year = 2016){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT (temp_min+temp_max)/2 FROM dataset_meteo WHERE DAY(fecha) = ? AND MONTH(fecha) = ? AND YEAR(fecha) = ?
        ")){
            $sql->bind_param("sss", $day, $month, $year);
            if($sql->execute())
                if(!$sql->bind_result($sum)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $sum;
        
    }   
    
    
   public function get_max_import(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT MAX(reg_sum)
            FROM
            (
               SELECT SUM(importe) AS reg_sum FROM dataset_cajamar 
               WHERE  1
               GROUP BY franja_horaria
            ) AS data
			")){
            
            if($sql->execute())
                if(!$sql->bind_result($max)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $max;
        
    } 
    
   public function get_min_import(){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT MIN(reg_sum)
            FROM
            (
               SELECT SUM(importe) AS reg_sum FROM dataset_cajamar 
               WHERE  1
               GROUP BY franja_horaria
            ) AS data
			")){
            
            if($sql->execute())
                if(!$sql->bind_result($max)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $max;
        
    } 
    
   public function get_max_import_cp($cp){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT MAX(reg_sum)
            FROM
            (
               SELECT SUM(importe) AS reg_sum FROM dataset_cajamar 
               WHERE  cp_cliente = ?
               GROUP BY franja_horaria
            ) AS data
			")){
            $sql->bind_param("s", $cp);
            if($sql->execute())
                if(!$sql->bind_result($max)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $max;
        
    }
    
   public function get_min_import_cp($cp){
        
        $db = new DataBase();
        if($sql = $db->mysqli->prepare("
            SELECT MAX(reg_sum)
            FROM
            (
               SELECT SUM(importe) AS reg_sum FROM dataset_cajamar 
               WHERE  cp_cliente = ?
               GROUP BY franja_horaria
            ) AS data
			")){
            $sql->bind_param("s", $cp);
            if($sql->execute())
                if(!$sql->bind_result($max)){
                    return false;
                }
        }
        else{
            return false;   
        }
        

        $sql->fetch();
        
        return $max;
        
    }
    
    public function get_month_name($num_month){
        switch($num_month){
            case 1:
                return 'ENE';
                break;
            case 2:
                return 'FEB';
                break;
            case 3:
                return 'MAR';
                break;
            case 4:
                return 'ABR';
                break;
            case 5:
                return 'MAY';
                break;
            case 6:
                return 'JUN';
                break;
            case 7:
                return 'JUL';
                break;
            case 8:
                return 'AGO';
                break;
            case 9:
                return 'SET';
                break;
            case 10:
                return 'OCT';
                break;
            case 11:
                return 'NOV';
                break;
            case 12:
                return 'DIC';
                break;
        }
    }
	
}

?>