library(tidyverse)

transacciones <- read.csv("dataset_card_analytics.txt", sep = "|", encoding = "UTF-8", stringsAsFactors = FALSE)
transacciones$IMPORTE <- as.numeric(gsub(",", ".", gsub("\\.", "", transacciones$IMPORTE)))

transacciones.por.cp <- transacciones %>% group_by(CP_COMERCIO) %>% summarise(VolumenVentas = sum(IMPORTE))
  
transacciones.por.cp <- rename(transacciones.por.cp, cp_comercio = CP_COMERCIO)  

write.csv(transacciones.por.cp, "transacciones_por_cpcomercio.csv")
